
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>【转】开放api接口签名验证 / 憋错料</title>

    <meta name="description" content="【转】开放api接口签名验证 不要急,源代码分享在最底部,先问大家一个问题,你在写开放的API接口时是如何保证数据的安全性的?先来看看有哪些安全性问题在开放的api接口中,我们通过http Post或者Get方式请求服务器的时候,会面临着许多的安全性问题,例如: 1. 请求来源(身份)是否合法? 2. 请求参数被篡改? 3. 请求的唯一性(不可复制) 为了保证数据在通信时的安全性,我们可以采用参数签名的方式来进行相关验证. 案列分析 我们通过给某 [移动端(app)] 写 [后台接口(api)] 的案例进行分析: 客户端:">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">【转】开放api接口签名验证</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>不要急，源代码分享在最底部，先问大家一个问题，你在写开放的API接口时是如何保证数据的安全性的？先来看看有哪些安全性问题在开放的api接口中，我们通过http Post或者Get方式请求服务器的时候，会面临着许多的安全性问题，例如：</p>
<ul>
<li>1. 请求来源(身份)是否合法？</li>
<li>2. 请求参数被篡改？</li>
<li>3. 请求的唯一性(不可复制)</li>
</ul>
<p>为了保证数据在通信时的安全性，我们可以采用参数签名的方式来进行相关验证。</p>
<p><strong>案列分析</strong></p>
<p>我们通过给某 [移动端(app)] 写 [后台接口(api)] 的案例进行分析：</p>
<p>客户端： 以下简称app</p>
<p>后台接口：以下简称api<br />我们通过app查询产品列表这个操作来进行分析：</p>
<p>app中点击查询按钮==》调用api进行查询==》返回查询结果==&gt;显示在app中</p>
<p><em>上代码啦 -_-！</em></p>
<p><strong>一、不进行验证的方式</strong></p>
<p>api查询接口：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE1Mzg1LzIwMTYxMS8xNTM4NS0yMDE2MTExMzE1MDYwNTIxNy0xMzA5MTUzMDAucG5n.jpg" /></p>
<p>app调用：http://api.test.com/getproducts?参数1=value1.......</p>
<p>如上，这种方式简单粗暴，通过调用getproducts方法即可获取产品列表信息了，但是 这样的方式会存在很严重的安全性问题，没有进行任何的验证，大家都可以通过这个方法获取到产品列表，导致产品信息泄露。<br />那么，如何验证调用者身份呢？如何防止参数被篡改呢？<br /><strong>二、MD5参数签名的方式</strong></p>
<p>我们对api查询产品接口进行优化：</p>
<p>1. 给app分配对应的key、secret</p>
<p>2. Sign签名，调用API 时需要对请求参数进行签名验证，签名方式如下：</p>
<p>a. 按照请求参数名称将所有请求参数按照字母先后顺序排序得到：keyvaluekeyvalue...keyvalue&nbsp; 字符串如：将arong=1,mrong=2,crong=3 排序为：arong=1, crong=3,mrong=2&nbsp; 然后将参数名和参数值进行拼接得到参数字符串：arong1crong3mrong2。</p>
<p>b. 将secret加在参数字符串的头部后进行MD5加密 ,加密后的字符串需大写。即得到签名Sign<br />新api接口代码:</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE1Mzg1LzIwMTYxMS8xNTM4NS0yMDE2MTExMzE1MDY0MDU3Ny00NjY0NDkyMzYucG5n.jpg" /></p>
<p>app调用：http://api.test.com/getproducts?<strong>key</strong>=app_key&amp;<strong>sign</strong>=BCC7C71CF93F9CDBDB88671B701D8A35&amp;参数1=value1&amp;参数2=value2.......</p>
<p><strong>注：secret 仅作加密使用, 为了保证数据安全请不要在请求参数中使用。</strong></p>
<p>如上，优化后的请求多了key和sign参数，这样请求的时候就需要合法的key和正确签名sign才可以获取产品数据。这样就解决了身份验证和防止参数篡改问题，如果请求参数被人拿走，没事，他们永远也拿不到secret,因为secret是不传递的。再也无法伪造合法的请求。<br />但是...这样就够了吗？细心的同学可能会发现，如果我获取了你完整的链接，一直使用你的key和sign和一样的参数不就可以正常获取数据了...-_-!是的，仅仅是如上的优化是不够的<br /><strong>请求的唯一性：</strong></p>
<p>为了防止别人重复使用请求参数问题，我们需要保证请求的唯一性，就是对应请求只能使用一次，这样就算别人拿走了请求的完整链接也是无效的。<br />唯一性的实现：在如上的请求参数中，我们加入时间戳 ：timestamp（yyyyMMddHHmmss），同样，时间戳作为请求参数之一，也加入sign算法中进行加密。<br />新的api接口：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzE1Mzg1LzIwMTYxMS8xNTM4NS0yMDE2MTExMzE1MDczMTEwOC0yMDY1NzcyMTk4LnBuZw==.jpg" /></p>
<p>app调用：<br />http://api.test.com/getproducts?<strong>key</strong>=app_key&amp;<strong>sign</strong>=BCC7C71CF93F9CDBDB88671B701D8A35&amp;<strong>timestamp</strong>=201603261407&amp;参数1=value1&amp;参数2=value2.......<br />如上，我们通过timestamp时间戳用来验证请求是否过期。这样就算被人拿走完整的请求链接也是无效的。</p>
<p><strong>Sign签名安全性分析：</strong></p>
<p>通过上面的案例，我们可以看出，安全的关键在于参与签名的secret，整个过程中secret是不参与通信的，所以只要保证secret不泄露，请求就不会被伪造。</p>
<p>总结</p>
<p>上述的Sign签名的方式能够在一定程度上防止信息被篡改和伪造，保障通信的安全，这里使用的是MD5进行加密，当然实际使用中大家可以根据实际需求进行自定义签名算法，比如：RSA，SHA等。</p>
<p><strong>相关方法源码分享：</strong></p>
<p>源码已托管至码云：<a href="https://git.oschina.net/daimali/Daimali.ISV" rel="external nofollow noreferrer">https://git.oschina.net/daimali/Daimali.ISV</a></p>
<p>来源：<a href="http://www.daimali.com/index.php/2016/04/27/241/" rel="external nofollow noreferrer">http://www.daimali.com/index.php/2016/04/27/241/</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 08:57:35 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/bsp/" title="bsp">bsp</a>, <a href="https://www.biecuoliao.com/tag/href/" title="href">href</a>, <a href="https://www.biecuoliao.com/tag/%e9%9c%80%e8%a6%81/" title="需要">需要</a>, <a href="https://www.biecuoliao.com/tag/%e5%93%aa%e4%ba%9b/" title="哪些">哪些</a>, <a href="https://www.biecuoliao.com/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.biecuoliao.com/tag/%e5%90%8e%e5%8f%b0/" title="后台">后台</a>, <a href="https://www.biecuoliao.com/tag/%e6%8c%89%e9%92%ae/" title="按钮">按钮</a>, <a href="https://www.biecuoliao.com/tag/products/" title="products">products</a>, <a href="https://www.biecuoliao.com/tag/%e6%8b%bc%e6%8e%a5/" title="拼接">拼接</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>【转】开放api接口签名验证的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eyewJ0.html" rel="bookmark">开放api接口签名验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不要急,源代码分享在最底部,先问大家一个问题,你在写开放的API接口时是如何保证数据的安全性的?先来看看有哪些安全性问题在开放的api接口中,我们通过http Post或者Get方式请求服务器的时候,会面临着许多的安全性问题,例如: 请求来源(身份)是否合法? 请求参数被篡改? 请求的唯一性(不可复制) 为了保证数据在通信时的安全性,我们可以采用参数签名的方式来进行相关验证. 案列分析 我们通过给某 [移动端(app)] 写 [后台接口(api)] 的案例进行分析: 客户端: 以下简称app 后			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49gw5p0.html" rel="bookmark">springcloud提供开放api接口签名验证</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.MD5参数签名的方式 我们对api查询产品接口进行优化: 1.给app分配对应的key.secret 2.Sign签名,调用API 时需要对请求参数进行签名验证,签名方式如下: a. 按照请求参数名称将所有请求参数按照字母先后顺序排序得到:keyvaluekeyvalue...keyvalue  字符串如:将arong=1,mrong=2,crong=3 排序为:arong=1, crong=3,mrong=2  然后将参数名和参数值进行拼接得到参数字符串:arong1crong3mrong			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz1jmO4.html" rel="bookmark">常用API接口签名验证参考</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				项目中常用的API接口签名验证方法: 1. 给app分配对应的key.secret2. Sign签名,调用API 时需要对请求参数进行签名验证,签名方式如下: a. 按照请求参数名称将所有请求参数按照字母先后顺序排序得到:keyvaluekeyvalue...keyvalue  字符串如:将arong=1,mrong=2,crong=3 排序为:arong=1, crong=3,mrong=2  然后将参数名和参数值进行拼接得到参数字符串:arong1crong3mrong2: b. 将secr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qE6GN3.html" rel="bookmark">Android测试工具ThreadingTest开放API接口说明</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ThreadingTest(简称TT)第一期是一款Android白盒测试工具,使用离线检测的方式,在保护用户源代码的基础上,运用插装.第五代覆盖率等技术,为开发工程师与测试工程师提供一套高效可量化.可视化的交流工具.对比其它测试工具,TT在自动化测试时,会对应测试用例自动生成测试用例和代码之间的关系以及函数覆盖率,并且以TT自带的双向追溯图进行展示,在整个自动化测试进行过程中,TT还会以示波器界面可视化的监控整个自动化测试中每时每刻获取的测试数据. 基于其它测试工具测试时,TT还开放了API接口			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02wjwn3.html" rel="bookmark">开放API接口 笑话、天气、新闻</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				笑话接口示例: http://api.1-blog.com/biz/bizserver/xiaohua/list.do?maxXhid=1000000&amp;size=1&amp;minXhid=6 开放API接口 笑话.天气.新闻 博客分类: 其它 API新闻笑话天气开放API 闲来无事,弄了几个API接口,分享给同样需(闲的)要(没事儿)的人吧 API接口都是HTTP形式的,数据都是json格式,支持ajax调用(已开放所有域名访问) PS:演示网站http://1-blog.com 使用的人麻烦加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49Oklg0.html" rel="bookmark">转载-常用API接口签名验证参考</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址: http://www.cnblogs.com/hnsongbiao/p/5478645.html 写的很好,就做个笔记了.感谢作者! 项目中常用的API接口签名验证方法: 1. 给app分配对应的key.secret2. Sign签名,调用API 时需要对请求参数进行签名验证,签名方式如下: a. 按照请求参数名称将所有请求参数按照字母先后顺序排序得到:keyvaluekeyvalue...keyvalue  字符串如:将arong=1,mrong=2,crong=3 排序为:aro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xz8wN4.html" rel="bookmark">开放API接口及其安全性</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开放出来给别人调用的API接口是就是开放API接口. 弱点: 数据窃取 用户的密码等信息被不轨之人窃取,登录账号发布敏感信息,盗刷等. 数据篡改 提交的数据被抓包后进行篡改再提交. 数据泄露 爬虫将业务数据甚至核心数据抓取,直接或者间接造成损失. RSA/DES加密 MD5混淆 TOKEN令牌 有令牌才能通过,没有令牌则不能通过 加密分为对称加密和非对称加密 对称加密有:DES,AES 加密和解密是使用同一套秘钥 非对称加密有:RSA 公钥和私钥 公钥加密,私钥解密 RSA可以用来加密和签名 H			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bzBmp0.html" rel="bookmark">几个开放API接口 笑话、天气、新闻</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				闲来无事,弄了几个API接口,分享给同样需(闲的)要(没事儿)的人吧API接口都是HTTP形式的,数据都是json格式,支持ajax调用(已开放所有域名访问) 笑话API 说明:调用后返回笑话列表,可以在参数中设置已经获取的最大笑话ID和最小笑话ID,返回结果会返回新的笑话(目前大概1w条左右,持续增加中)使用方式请求地址:http://114.215.158.105:8080/bizserver/xiaohua/list.do示例 http://114.215.158.105:8080/htm			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dRaD64.html" rel="bookmark">远程开户系统开放API接口</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如今随着智能识别技术的成熟和商用,金融领域也开始逐渐试水&quot;远程开户&quot;.从OCR身份证识别到人脸识别,到如今市场上即将出现完整的远程开户系统,除了需要成熟的技术做支撑外,还需要对市场有着前瞻性的眼光. 这套远程开户系统包含了OCR身份证识别技术.银行卡识别技术.人脸识别等智能识别技术.即利用身份证识别快速采集验证用户身份,并通过联网核查进行验证身份信息,用来核实用户的真实身份;然后利用银行卡识别一键绑定银行卡,再辅以视频人脸识别进行身份进一步验证,确保开户者与证件持有者为同一人,做到人证			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/VMGjob4.html" rel="bookmark" class="title">对自己的角色，及需要做的技术准备工作深入思考</a>
					<div>
						根据团队计划,我的负责代码编写及测试,就是做程序开发及测试.我需要学习安卓开发,java编程,PHP,学会应用Eclipse和Android SDK,熟悉网络协议等等.虽然我现在已经学了java编程, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j5p6AM.html" rel="bookmark" class="title">matlab调试时子函数断点不起作用</a>
					<div>
						matlab调试代码时总是遇到这样一个奇怪的问题,就是当我在主程序(.m脚本)中调用子函数并在子函数中设置断点,然后开始调试运行主程序... 发现主程序直接运行到结束而并没有在调用子函数的时候在所设置 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Am6QK4.html" rel="bookmark" class="title">DOM元素尺寸和位置</a>
					<div>
						一.获取元素 CSS大小 1.通过style 内联获取元素的大小 var box = document.getElementById('box'); //获取元素 box.style.width; / ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDoNep4.html" rel="bookmark" class="title">vs2015 error c4996&colon; &amp;&num;39&semi;fopen&amp;&num;39&semi;&colon; This function or variable may be unsafe</a>
					<div>
						使用vs2015打开图片,遇到如下错误. 1&gt;------ 已启动生成: 项目: ImageScale3, 配置: Debug Win32 ------1&gt; ImageScale3Dlg. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02kg223.html" rel="bookmark" class="title">关注C&plus;&plus;细节&mdash;&mdash;字面值初始化字符数组及字符串拷贝注意</a>
					<div>
						char carr[] = &quot;author:CSDN-iaccepted&quot;; 此时,carr数组中元素的个数为21,最后一个位置用来存放空字符'\0'. 所以如果写成carr[21 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lWJ1WM.html" rel="bookmark" class="title">avalon2框架应用注意事项</a>
					<div>
						采用avalon2框架的项目结束了,大家都第一次使用这个框架,难免踩到坑.这里是一份项目组人员归纳出来的几个注意点,分享出来希望能帮到大家. domReady后如何扫描 $(function(){ v ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRXPO3.html" rel="bookmark" class="title">十几万连接几M的流量，吓死&OpenCurlyDoubleQuote;宝宝&rdquo;了</a>
					<div>
						某局点升级(nginx变ats,同时去掉前端的nginx负载层),升级之后服务就不正常,硬生生的看着十几万连接,没有流量,各种排错,可谓是把心提到嗓子眼惊心动魄的半小时,虽然做了很好的业务机制,服务不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6z6OZM.html" rel="bookmark" class="title">Distributed R</a>
					<div>
						R语言的分布式目前有这几个产品: (A)RHadoop:对hadoop族系的产品,其中提供了以下的组件 A.1 rhdfs  浏览读取增加修改hdfs上面的文件数据: A.2 rhbase 浏览读取增 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLvplk3.html" rel="bookmark" class="title">ASP最新评论功能调用方法</a>
					<div>
						调用: 评论列表 &lt;script language=&quot;javascript&quot; src=&quot;/{aspcms:sitepath}plug/comment.asp?id= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVqlv24.html" rel="bookmark" class="title">WebView 和 JS</a>
					<div>
						android webview js交互 第一节 (java和js交互) http://blog.csdn.net/wangtingshuai/article/details/8631835 Andr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWGmK0.html" rel="bookmark" class="title">Hibernate（1）&mdash;&mdash;数据访问层的架构模式&amp;lt&semi;转&amp;gt&semi;</a>
					<div>
						数据库的概念.逻辑.数据模型概念 应用程序的分层体系结构发展 MVC设计模式与四层结构的对应关系 持久层的设计目标 数据映射器架构模式 JDBC的缺点 Hibernate简介 迅速使用Hibernat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkevw3.html" rel="bookmark" class="title">无密码ssh远程机器</a>
					<div>
						双台 无密码访问  A---&gt;B---&gt;A 第一步需要在服务器A生成密钥对,将生成的公钥上传到服务器B的相关用户目录下的.ssh目录中(没有的话手动创建,注意,它的目录权限是700), 第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Op7xK4.html" rel="bookmark" class="title">【转】Drag and Drop files from Windows Explorer toWindows Form</a>
					<div>
						http://www.codeproject.com/Articles/3598/Drag-and-Drop-files-from-Windows-Explorer-to-Windo [转]Drag  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXZGDQ3.html" rel="bookmark" class="title">Java之集合&lpar;十四&rpar;Hashtable</a>
					<div>
						转载请注明源出处:http://www.cnblogs.com/lighten/p/7426522.html 1.前言 HashTable这个类很奇特,其继承了Dictionary这个没有任何具体实现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Oplno4.html" rel="bookmark" class="title">错误记录--更改tomcat端口号方法，Several ports &lpar;8005&comma; 8080&comma; 8009&rpar;&lpar;转&rpar;</a>
					<div>
						启动Tomcat服务器报错: Several ports (8005, 8080, 8009) required by Tomcat v5.5 Server at localhost are alre ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Rjbx70.html" rel="bookmark" class="title">mysql--实现oracle的row&lowbar;number&lpar;&rpar; over功能</a>
					<div>
						有时候我们想要得到每个分组的前几条记录,这个时候oracle中row_number函数使用非常方便,但可惜mysql没有.网上搜了些实现方法. 表flow_task有phaseno(序列号),obje ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41yN8X4.html" rel="bookmark" class="title">HDU 4915 多校5 Parenthese sequence</a>
					<div>
						比赛的时候想了一个自认为对的方法,WA到死,然后还一直敲下去,一直到晚上才想到反例 找是否存在解比较好找,这种左右括号序列,把(当成1,把)当成-1,然后从前往后扫,+1或者-1 遇到?就当初(,然后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pDdJR4.html" rel="bookmark" class="title">php 的 危 险 参 数</a>
					<div>
						hpinfo() 功能描述:输出 PHP 环境信息以及相关的模块.WEB 环境等信息. 危险等级:中 passthru() 功能描述:允许执行一个外部程序并回显输出,类似于 exec(). 危险等级: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jwB6W3.html" rel="bookmark" class="title">HDOJ--1285--确定比赛名次</a>
					<div>
						确定比赛名次 Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Sub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPgW6B4.html" rel="bookmark" class="title">（新手篇）嵌入式Linux C 语言编程环境</a>
					<div>
						嵌入式Linux C 语言编程环境有四部分 1.编译器vi 1.1 vi的基本模式 1.1.1 命令模式(Command Mode) 在该模式下输入命令来控制屏幕光标的移动,字符.单词或行的删除,移动 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
